﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Diagnostics;

namespace AttributeDemo
{

    [assembly : Help("This Assembly demonstrates custom attributes creation and their run-time query.")]

//our custom attribute class
    public class HelpAttribute : Attribute
    {
        public HelpAttribute(String Description_in)
        {
            //
            // TODO: Add constructor logic here
            this.description = Description_in;
            //
        }
        protected String description;
        public String Description
        {
            get 
            {
                return this.description;
                     
            }            
        }    
    }
    //attaching Help attribute to our AnyClass
    [Help("This is a do-nothing Class.")]
    public class AnyClass
    {
        //attaching Help attribute to our AnyMethod
        [Help("This is a do-nothing Method.")]
        public void AnyMethod()
        {
        }

        //attaching Help attribute to our AnyInt Field
        [Help("This is any Integer.")]
        public int AnyInt;
    }

    public  class Program
    {
        //static void Main(string[] args)
        //{
        //}

        public static void Main()
        {

            Type type = typeof(AnyClass);

            HelpAttribute helpAttr;


            foreach (Attribute attr in type.GetCustomAttributes(true))
            {
                helpAttr = attr as HelpAttribute;
                if (attr != null)
                {
                    Console.WriteLine("Description of AnyClass:\n{0}",
                        helpAttr.Description);
                }
            }

            Console.WriteLine();
            foreach (MethodInfo method in type.GetMethods())
            {
                foreach (Attribute attr in method.GetCustomAttributes(true))
                {
                    helpAttr = attr as HelpAttribute;
                    if (helpAttr != null)
                    {
                        Console.WriteLine("Description of {0}:\n {1}",
                            method.Name, helpAttr.Description);
                    }
                }
            }

            Console.WriteLine();

            foreach (FieldInfo field in type.GetFields())
            {
                foreach (Attribute attr in field.GetCustomAttributes(true))
                {
                    helpAttr = attr as HelpAttribute;
                    if (helpAttr != null)
                    {
                        Console.WriteLine("Description of {0}:\n{1}",
                            field.Name, helpAttr.Description);
                    }
                }
            }

            Console.WriteLine();

            string assemblyName;

            Process p = Process.GetCurrentProcess();

            assemblyName = p.ProcessName + ".exe";

            Assembly a = Assembly.LoadFrom(assemblyName);

            AnyClass anyClass = new AnyClass();

            foreach (Attribute attr in a.GetCustomAttributes(false))
            {
                helpAttr = attr as HelpAttribute;

                if (helpAttr != null)
                {
                    Console.WriteLine("Description of {0}:\n{1}",
                        assemblyName, helpAttr.Description);
                }
            }

            Console.ReadLine();
        }
    }
}
